/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIDOMMessageEvent.idl
 */

#ifndef __gen_nsIDOMMessageEvent_h__
#define __gen_nsIDOMMessageEvent_h__


#ifndef __gen_nsIDOMEvent_h__
#include "nsIDOMEvent.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIDOMMessageEvent */
#define NS_IDOMMESSAGEEVENT_IID_STR "3cf6163e-0227-49d9-b52b-f061828fb9b8"

#define NS_IDOMMESSAGEEVENT_IID \
  {0x3cf6163e, 0x0227, 0x49d9, \
    { 0xb5, 0x2b, 0xf0, 0x61, 0x82, 0x8f, 0xb9, 0xb8 }}

/**
 * The nsIDOMMessageEvent interface is used for server-sent events and for
 * cross-domain messaging.
 *
 * For more information on this interface, please see
 * http://www.whatwg.org/specs/web-apps/current-work/multipage/section-event0.html#event0
 */
class NS_NO_VTABLE nsIDOMMessageEvent : public nsIDOMEvent {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IDOMMESSAGEEVENT_IID)

  /**
   * Custom string data associated with this event.
   */
  /* readonly attribute DOMString data; */
  NS_IMETHOD GetData(nsAString & aData) = 0;

  /**
   * The domain of the site from which this event originated.
   */
  /* readonly attribute DOMString domain; */
  NS_IMETHOD GetDomain(nsAString & aDomain) = 0;

  /**
   * The URI of the site from which this event was created.
   */
  /* readonly attribute DOMString uri; */
  NS_IMETHOD GetUri(nsAString & aUri) = 0;

  /**
   * The window which originated this event.
   */
  /* readonly attribute nsIDOMWindow source; */
  NS_IMETHOD GetSource(nsIDOMWindow * *aSource) = 0;

  /**
   * Initializes this event with the given data, in a manner analogous to
   * the similarly-named method on the nsIDOMEvent interface, also setting the
   * data, domain, uri, and source attributes of this appropriately.
   */
  /* void initMessageEvent (in DOMString aType, in boolean aCanBubble, in boolean aCancelable, in DOMString aData, in DOMString aDomain, in DOMString aURI, in nsIDOMWindow aSource); */
  NS_IMETHOD InitMessageEvent(const nsAString & aType, PRBool aCanBubble, PRBool aCancelable, const nsAString & aData, const nsAString & aDomain, const nsAString & aURI, nsIDOMWindow *aSource) = 0;

  /**
   * Initializes this event with the given data, in a manner analogous to
   * the similarly-named method on the Event interface, also setting the data,
   * domain, uri, and source attributes of this appropriately.
   */
  /* void initMessageEventNS (in DOMString aNamespaceURI, in DOMString aType, in boolean aCanBubble, in boolean aCancelable, in DOMString aData, in DOMString aDomain, in DOMString aURI, in nsIDOMWindow aSource); */
  NS_IMETHOD InitMessageEventNS(const nsAString & aNamespaceURI, const nsAString & aType, PRBool aCanBubble, PRBool aCancelable, const nsAString & aData, const nsAString & aDomain, const nsAString & aURI, nsIDOMWindow *aSource) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIDOMMessageEvent, NS_IDOMMESSAGEEVENT_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIDOMMESSAGEEVENT \
  NS_IMETHOD GetData(nsAString & aData); \
  NS_IMETHOD GetDomain(nsAString & aDomain); \
  NS_IMETHOD GetUri(nsAString & aUri); \
  NS_IMETHOD GetSource(nsIDOMWindow * *aSource); \
  NS_IMETHOD InitMessageEvent(const nsAString & aType, PRBool aCanBubble, PRBool aCancelable, const nsAString & aData, const nsAString & aDomain, const nsAString & aURI, nsIDOMWindow *aSource); \
  NS_IMETHOD InitMessageEventNS(const nsAString & aNamespaceURI, const nsAString & aType, PRBool aCanBubble, PRBool aCancelable, const nsAString & aData, const nsAString & aDomain, const nsAString & aURI, nsIDOMWindow *aSource); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIDOMMESSAGEEVENT(_to) \
  NS_IMETHOD GetData(nsAString & aData) { return _to GetData(aData); } \
  NS_IMETHOD GetDomain(nsAString & aDomain) { return _to GetDomain(aDomain); } \
  NS_IMETHOD GetUri(nsAString & aUri) { return _to GetUri(aUri); } \
  NS_IMETHOD GetSource(nsIDOMWindow * *aSource) { return _to GetSource(aSource); } \
  NS_IMETHOD InitMessageEvent(const nsAString & aType, PRBool aCanBubble, PRBool aCancelable, const nsAString & aData, const nsAString & aDomain, const nsAString & aURI, nsIDOMWindow *aSource) { return _to InitMessageEvent(aType, aCanBubble, aCancelable, aData, aDomain, aURI, aSource); } \
  NS_IMETHOD InitMessageEventNS(const nsAString & aNamespaceURI, const nsAString & aType, PRBool aCanBubble, PRBool aCancelable, const nsAString & aData, const nsAString & aDomain, const nsAString & aURI, nsIDOMWindow *aSource) { return _to InitMessageEventNS(aNamespaceURI, aType, aCanBubble, aCancelable, aData, aDomain, aURI, aSource); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIDOMMESSAGEEVENT(_to) \
  NS_IMETHOD GetData(nsAString & aData) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetData(aData); } \
  NS_IMETHOD GetDomain(nsAString & aDomain) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDomain(aDomain); } \
  NS_IMETHOD GetUri(nsAString & aUri) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetUri(aUri); } \
  NS_IMETHOD GetSource(nsIDOMWindow * *aSource) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSource(aSource); } \
  NS_IMETHOD InitMessageEvent(const nsAString & aType, PRBool aCanBubble, PRBool aCancelable, const nsAString & aData, const nsAString & aDomain, const nsAString & aURI, nsIDOMWindow *aSource) { return !_to ? NS_ERROR_NULL_POINTER : _to->InitMessageEvent(aType, aCanBubble, aCancelable, aData, aDomain, aURI, aSource); } \
  NS_IMETHOD InitMessageEventNS(const nsAString & aNamespaceURI, const nsAString & aType, PRBool aCanBubble, PRBool aCancelable, const nsAString & aData, const nsAString & aDomain, const nsAString & aURI, nsIDOMWindow *aSource) { return !_to ? NS_ERROR_NULL_POINTER : _to->InitMessageEventNS(aNamespaceURI, aType, aCanBubble, aCancelable, aData, aDomain, aURI, aSource); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsDOMMessageEvent : public nsIDOMMessageEvent
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIDOMMESSAGEEVENT

  nsDOMMessageEvent();

private:
  ~nsDOMMessageEvent();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsDOMMessageEvent, nsIDOMMessageEvent)

nsDOMMessageEvent::nsDOMMessageEvent()
{
  /* member initializers and constructor code */
}

nsDOMMessageEvent::~nsDOMMessageEvent()
{
  /* destructor code */
}

/* readonly attribute DOMString data; */
NS_IMETHODIMP nsDOMMessageEvent::GetData(nsAString & aData)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute DOMString domain; */
NS_IMETHODIMP nsDOMMessageEvent::GetDomain(nsAString & aDomain)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute DOMString uri; */
NS_IMETHODIMP nsDOMMessageEvent::GetUri(nsAString & aUri)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIDOMWindow source; */
NS_IMETHODIMP nsDOMMessageEvent::GetSource(nsIDOMWindow * *aSource)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void initMessageEvent (in DOMString aType, in boolean aCanBubble, in boolean aCancelable, in DOMString aData, in DOMString aDomain, in DOMString aURI, in nsIDOMWindow aSource); */
NS_IMETHODIMP nsDOMMessageEvent::InitMessageEvent(const nsAString & aType, PRBool aCanBubble, PRBool aCancelable, const nsAString & aData, const nsAString & aDomain, const nsAString & aURI, nsIDOMWindow *aSource)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void initMessageEventNS (in DOMString aNamespaceURI, in DOMString aType, in boolean aCanBubble, in boolean aCancelable, in DOMString aData, in DOMString aDomain, in DOMString aURI, in nsIDOMWindow aSource); */
NS_IMETHODIMP nsDOMMessageEvent::InitMessageEventNS(const nsAString & aNamespaceURI, const nsAString & aType, PRBool aCanBubble, PRBool aCancelable, const nsAString & aData, const nsAString & aDomain, const nsAString & aURI, nsIDOMWindow *aSource)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIDOMMessageEvent_h__ */
